package com.jwipc.sys.controller.pc;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson2.JSON;
import com.jwipc.page.PageView;
import com.jwipc.sys.dto.FileResposeDTO;
import com.jwipc.sys.dto.SupplierEmailDTO;
import com.jwipc.sys.dto.SysConfigDTO;
import com.jwipc.sys.logic.SupplierEmailLogic;
import com.jwipc.sys.logic.SysConfigLogic;
import com.jwipc.sys.model.query.SupplierEmailQuery;
import com.jwipc.sys.model.query.SysConfigQuery;
import com.jwipc.util.EasyExcelUtils;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Date;
import java.util.List;

import static com.jwipc.sys.constant.ModuleConst.MODULE_ROOT;

/**
 * @author shenyang.ou
 * @date 2024/2/2 16:52
 * @desc 系统配置
 */
@RestController
@RequestMapping(MODULE_ROOT + "/supplierEmail/rest")
@RequiredArgsConstructor
public class SupplierEmailRestController {
    private final SysConfigLogic sysConfigLogic;
    private final SupplierEmailLogic supplierEmailLogic;

    /**
     * 列表
     * @param query
     * @return
     */
    @RequestMapping("/list")
    public PageView list(SupplierEmailQuery query) {
        return supplierEmailLogic.findByPage(query);
    }


    /**
     * 列表
     * @param query
     * @return
     */
    @RequestMapping("/listAll")
    public List<SysConfigDTO> listAll(SysConfigQuery query) {
        return sysConfigLogic.listAll(query);
    }

    /**
     * 保存更新
     *
     * @param param 参数
     */
    @PostMapping("/saveOrUpdate")
    public ResponseEntity saveOrUpdate(SupplierEmailDTO param) {
        supplierEmailLogic.saveOrUpdate(param);
        return ResponseEntity.ok(true);
    }

    /**
     * 配置数据状态更新
     *
     * @param ids    配置数据的ID集合
     * @param status 变更的状态 0:启用 1:禁用
     * @return 结果
     */
    @PostMapping("/status/update")
    public ResponseEntity updateStatus(String ids, Integer status) {
        sysConfigLogic.updateStatus(ids,status);
        return ResponseEntity.ok(true);
    }

    /**
     * 稽核列表导出
     * @param exportFiled 导出的列信息
     * @param queryStr 查询条件
     */
    @PostMapping("/export")
    public void export(HttpServletResponse response, String exportFiled, String queryStr) throws IOException {
        // 查询数据列表，直接调用列表的查询，无需特殊改动
        final List<SupplierEmailDTO> exportData = supplierEmailLogic.listAll(JSON.parseObject(queryStr, SupplierEmailQuery.class));
        //动态导出工具类，只需要修改导出excel名称
        EasyExcelUtils.trendsModelWrite(response,"供应商邮箱配置导出-" + DateUtil.format(new Date(), DatePattern.NORM_DATE_PATTERN),"sheet", exportData, exportFiled);
    }

    /**
     * 稽核列表导入
     * @param file 导出的列信息
     */
    @PostMapping("import")
    public ResponseEntity importData(@RequestParam(value = "file") MultipartFile file) {
        supplierEmailLogic.itemImportData(file);
        return ResponseEntity.ok().build();
    }

    /**
     * 删除
     *
     * @param id 参数
     */
    @PostMapping("/remove")
    public ResponseEntity remove(Long id) {
        supplierEmailLogic.remove(id);
        return ResponseEntity.ok(true);
    }

    /**
     * 获取文本型系统参数
     * @param key 唯一编码
     * @return 参数
     */
    @GetMapping("/getTextConfig")
    public String getTextConfig(String key) {
        return sysConfigLogic.getTextConfig(key);
    }

    /**
     * 获取附件型文件
     *
     * @param key 唯一编码
     * @return 文件
     */
    @GetMapping("/getFileConfig")
    public FileResposeDTO getFileConfig(String key) {
        return sysConfigLogic.getFileConfig(key);
    }

    /**
     * 获取单选型系统参数
     *
     * @param key 唯一编码
     * @return 参数 0-否；1-是
     */
    @GetMapping("/getRadioConfig")
    public Integer getRadioConfig(String key) {
        return sysConfigLogic.getRadioConfig(key);
    }
}
